<template>
  <div class="ele-body">
    <el-card shadow="never" v-loading="loading">
      <productionPlan-search
        @search="reload"
        ref="searchRef"
        :statusOpt="statusOpt"
        :planType="planType"
        :activeName="activeName"
      >
      </productionPlan-search>
      <div class="btn_box">
        <el-button type="success" size="mini">齐套性检查</el-button>
        <el-button type="primary" size="mini" @click="disassemblePlan"
          >计划分解</el-button
        >
        <el-button type="primary" size="mini">补单计划</el-button>
        <el-button type="info" size="mini">计划行事历</el-button>
        <el-button type="warning" size="mini">预警设置</el-button>
        <el-button type="primary" size="mini" @click="handleMerge"
          >合批</el-button
        >
        <el-button type="danger" size="mini">延期申请</el-button>
        <el-button type="danger" size="mini">变更申请</el-button>

        <el-button type="success" size="mini" v-if="timeDimensionPlanType == 3"
          >新增</el-button
        >
      </div>

      <el-tabs v-model="activeName" type="card" size="mini">
        <el-tab-pane label="未发布" name="first"></el-tab-pane>
        <el-tab-pane label="已发布" name="second"></el-tab-pane>
        <el-tab-pane label="已变更" name="change"></el-tab-pane>
      </el-tabs>
      <!-- 数据表格 -->
      <ele-pro-table
        ref="table"
        :key="activeName"
        :initLoad="false"
        :columns="newColumns"
        :datasource="datasource"
        row-key="code"
        :selection.sync="selection"
        :cache-key="`${activeName}ProductionPlanTable`"
        @sort-change="onSortChange"
        autoAmendPage
        :parse-data="parseData"
        @update:selection="handleSelectionChange"
      >
        <template v-slot:batchNo="{ row }">
          <el-link type="primary" :underline="false">
            <!-- @click.stop="splitDetails(1, row)" -->
            <el-tag type="success" size="mini" v-if="row.joinPlanCode">
              拆</el-tag
            >

            <el-tag
              type="danger"
              size="mini"
              v-if="row.splitBatch == 2"
              @click.stop="splitDetails(2, row)"
            >
              合</el-tag
            >
            {{ row.batchNo }}
          </el-link>
        </template>

        <template v-slot:selection="{ row }">
          <div class="check_box" @click="handOneSelection(row)">
            <div class="check act_check" v-if="selectionFilter(row)">
              <i class="el-icon-check"></i>
            </div>
            <div class="check" v-else></div>
          </div>
        </template>

        <template v-slot:code="{ row }">
          <el-link type="primary" :underline="false" @click="goDetail(row)">
            {{ row.code }}
          </el-link>
        </template>

        <template v-slot:salesCode="{ row }">
          {{ row.salesCode }}
        </template>

        <template v-slot:priority="{ row }">
          <div style="display: flex">
            <el-input
              v-model="row.priority"
              type="number"
              size="mini"
              :min="0"
              :max="10"
              @change="priorityChange(row)"
              style="width: 80px"
            >
            </el-input>

            <el-popover
              placement="right"
              width="200"
              trigger="hover"
              content="数值越大优先级越高（0-3普通, 4-6优先, 7-10紧急）"
            >
              <div class="sort-wrap" slot="reference">
                <i class="el-icon-caret-top" @click="sortTop(row)"></i>
                <i class="el-icon-caret-bottom" @click="sortBottom(row)"></i>
              </div>
            </el-popover>
          </div>
        </template>

        <template v-slot:productNum="{ row }">
          {{ row.productNum }} {{ row.unit }}
        </template>

        <template v-slot:productWeight="{ row }">
          {{ row.productWeight }} {{ row.weightUnit }}
        </template>

        <template v-slot:requiredFormingNum="{ row }">
          {{ row.requiredFormingNum }} {{ row.unit }}
        </template>

        <template v-slot:newSumOrderWeight="{ row }">
          {{ row.newSumOrderWeight }} {{ row.newWeightUnit }}
        </template>

        <template v-slot:status="{ row }">
          <span :class="{ 'ele-text-danger': row.status == 3 }">
            {{ statusFormatter(row.status) }}
          </span>
        </template>
        <!-- 操作列 -->
        <template v-slot:action="{ row }">
          <el-link
            type="primary"
            :underline="false"
            v-if="row.status == 2 && row.splitBatch != 1"
            @click="handleOrderPublish(1, row)"
          >
            发布
          </el-link>
          <el-link
            type="primary"
            v-if="row.status == 3"
            :underline="false"
            @click="handleOrderPublish(2, row)"
          >
            重新发布
          </el-link>

          <el-link
            v-if="
              row.splitBatch != 2 &&
              row.splitBatch != 1 &&
              !row.joinPlanCode &&
              activeName == 'first'
            "
            type="primary"
            :underline="false"
            @click="planEdit(row)"
          >
            修改
          </el-link>

          <el-link
            v-if="row.joinPlanCode && activeName == 'first' && row.status != 4"
            type="danger"
            :underline="false"
            @click="handleDel(row)"
          >
            删除
          </el-link>

          <el-link
            v-if="
              clientEnvironmentId != 4 &&
              activeName == 'first' &&
              row.splitBatch != 2 &&
              !row.joinPlanCode
            "
            type="primary"
            :underline="false"
            @click="toUnpack(row)"
          >
            拆批
          </el-link>
        </template>
      </ele-pro-table>
    </el-card>

    <unpackDialog ref="unpackRef" @success="reload" />

    <mergeDialog ref="mergeRef" @success="reload"></mergeDialog>

    <unpackDetails ref="DetailsRef"></unpackDetails>

    <disassemblePlanPop ref="disassemblePlanRef"></disassemblePlanPop>
     
  </div>
</template>

<script>
  import { getList, del, updatePriority } from '@/api/productionPlan/index.js';
  import productionPlanSearch from './components/productionPlan-search.vue';
  import unpackDialog from './components/unpackDialog.vue';
  import mergeDialog from './components/mergeDialog.vue';
  import unpackDetails from './components/unpackDetails.vue';
  import disassemblePlanPop from './components/disassemblePlanPop.vue';
  import { release } from '@/api/productionPlan/order.js';
  import { getCode } from '@/api/codeManagement';
  import { fieldModel } from '@/api/saleOrder';
  import { debounce } from 'lodash';
  export default {
    components: {
      productionPlanSearch,
      unpackDialog,
      mergeDialog,
      unpackDetails,
      disassemblePlanPop
    },
    props: {
      timeDimensionPlanType: { type: Number, default: 1 }
    },
    data() {
      return {
        activeName: 'first',

        // 加载状态
        loading: false,
        pageType: 'add',
        dialogTitle: '',
        isBindPlan: false,
        statusOpt: {
          first: [
            { label: '所有状态', value: '3,2' },
            { label: '待发布', value: '2' },
            { label: '发布失败', value: '3' },
            { label: '已发布', value: '4' }
          ],
          second: [
            { label: '所有状态', value: '7,4,5,6' },
            { label: '待生产', value: '4' },
            { label: '生产中', value: '5' },
            { label: '已完成', value: '6' },
            { label: '已延期', value: '7' }
          ],
          change: [{ label: '已变更', value: '9' }]
        },
        planType: [
          { label: '所有计划类型', value: null },
          { label: '内销计划', value: '1' },
          { label: '外销计划', value: '2' },
          { label: '预制计划', value: '3' }
        ],
        newColumns: [],

        selection: []
      };
    },
    computed: {
      clientEnvironmentId() {
        return this.$store.state.user.info.clientEnvironmentId;
      },
      // 表格列配置
      columns() {
        const opt = {
          first: [],
          second: [
            {
              prop: 'releaseTime',
              label: '工单发布日期',
              align: 'center',

              minWidth: 110
            },
            {
              prop: 'planFormingTime',
              label: '预测生产日期',
              align: 'center',

              minWidth: 110
            },
            {
              prop: 'deliveryTime',
              label: '预测交货日期',
              align: 'center',

              minWidth: 110
            },
            {
              prop: 'formingTime',
              label: '实际交货日期',
              align: 'center',

              minWidth: 110
            }
          ],
          change: []
        };

        return [
          {
            width: 45,
            type: 'selection',
            columnKey: 'selection',
            align: 'center',
            slot: 'selection'
          },
          {
            columnKey: 'index',
            label: '序号',
            type: 'index',
            width: 55,
            align: 'center',
            showOverflowTooltip: true
          },

          {
            slot: 'batchNo',
            prop: 'batchNo',
            label: '批次号',
            align: 'center',
            minWidth: 140
          },

          {
            slot: 'code',
            prop: 'code',
            action: 'code',
            label: '计划编号',
            align: 'center',

            minWidth: 160,
            sortable: true
          },

          {
            prop: 'salesCode',
            action: 'salesCode',
            label: '销售订单号',
            align: 'center',

            minWidth: 160
          },

          {
            prop: 'productCode',
            label: '产品编码',
            align: 'center',

            minWidth: 140
          },
          {
            prop: 'productName',
            label: '产品名称',
            align: 'center',

            minWidth: 140
          },

          {
            prop: 'brandNo',
            label: '牌号',
            align: 'center',
            showOverflowTooltip: true
          },

          {
            prop: 'specification',
            label: '规格',
            align: 'center',
            minWidth: 150,

            showOverflowTooltip: true
          },
          {
            prop: 'model',
            label: '型号',
            align: 'center',
            showOverflowTooltip: true
          },

          {
            prop: 'priority',
            label: '优先级',
            align: 'center',
            minWidth: 120,
            slot: 'priority',
            sortable: 'custom'
          },

          {
            prop: 'produceRoutingName',
            label: '工艺路线',
            align: 'center',
            minWidth: 120
          },

          {
            prop: 'productNum',
            label: '计划数量',
            align: 'center',

            slot: 'productNum'
          },
          {
            prop: 'productWeight',
            label: '计划重量',
            align: 'center',

            slot: 'productWeight'
          },
          {
            prop: 'requiredFormingNum',
            label: '要求生产数量',
            align: 'center',

            slot: 'requiredFormingNum'
          },

          {
            prop: 'newSumOrderWeight',
            label: '要求生产重量',
            align: 'center',

            slot: 'newSumOrderWeight'
          },

          {
            prop: 'scheduleStatusName',
            label: '进度状态',
            align: 'center',

            minWidth: 100
          },

          {
            prop: '',
            label: '已排产数量',
            align: 'center',
            showOverflowTooltip: true
          },

          {
            prop: '',
            label: '未排产数量',
            align: 'center',
            showOverflowTooltip: true
          },

          {
            prop: '',
            label: '已生产数量',
            align: 'center',
            showOverflowTooltip: true
          },

          {
            prop: '',
            label: '未生产数量',
            align: 'center',
            showOverflowTooltip: true
          },

          {
            prop: 'moCount',
            label: '模数',
            align: 'center',
            show: this.clientEnvironmentId == '4'
          },

          {
            prop: 'blockCount',
            label: '块数',
            align: 'center',
            show: this.clientEnvironmentId == '4'
          },
          {
            prop: 'noWordCount',
            label: '未排程块数',
            align: 'center',

            show: this.clientEnvironmentId == '4',
            minWidth: 110
          },
          {
            prop: 'reqMoldTime',
            label: '计划完成日期',
            align: 'center',

            minWidth: 110
          },

          ...opt[this.activeName],

          {
            prop: 'orderType',
            label: '计划类型',
            align: 'center',

            formatter: (row) => {
              const obj = this.planType.find((i) => i.value == row.planType);
              return obj && obj.label;
            }
          },
          {
            prop: 'version',
            label: '版本',
            align: 'center',

            minWidth: 80
          },
          {
            prop: 'createTime',
            label: '创建时间',
            align: 'center',

            minWidth: 110
          },
          {
            columnKey: 'status',
            slot: 'status',
            label: '状态',
            align: 'center',
            formatter: (row) => {
              const obj = this.statusOpt[this.activeName].find(
                (i) => i.value == row.status
              );
              return obj && obj.label;
            }
          }
        ];
      }
    },
    created() {
      this.getFieldModel();
    },
    methods: {
      statusFormatter(status) {
        const obj = this.statusOpt[this.activeName].find(
          (i) => i.value == status
        );

        return obj && obj.label;
      },
      /* 表格数据源 */
      datasource({ page, limit, where }) {
        return getList({
          pageNum: page,
          timeDimensionPlanType: this.timeDimensionPlanType,
          size: limit,
          ...where,
          ...this.sort
        });
      },
      // 发布工单
      handleOrderPublish(type, row) {
        if (!row.produceRoutingName) {
          return this.$message.error('请先选择工艺路线！');
        }

        this.$confirm('发布工单后不可撤回，确定发布吗？', '发布确认')
          .then(async () => {
            const loading = this.$loading({
              lock: true,
              fullscreen: true,
              text: '工单发布中...'
            });
            try {
              let code = row.workOrderCode;
              if (!code) {
                code = await getCode('product_order_code');
              }
              // 反显对象会报错 status
              const data = await release([row.id]);
              if (data || data === 0) {
                this.$message.success('发布成功！');
              } else {
                this.$message.error('发布失败，请重新发布！');
              }
              this.reload();
            } catch (error) {
              console.error(error);
            }
            loading.close();
          })
          .catch((err) => {
            console.error(err);
          });

        // this.$router.push({
        //   path: '/productionPlan/workOrderPublish',
        //   query: {
        //     type,
        //     id: row.id
        //   }
        // });
      },
      // 修改计划
      planEdit({ id }) {
        this.$router.push({
          path: '/saleOrder/salesToProduction',
          query: {
            type: 'edit',
            id
          }
        });
      },

      getFieldModel() {
        fieldModel({ fieldModel: 't_main_category' }).then((res) => {
          const privateColumn = [];
          if (this.activeName == 'first') {
            privateColumn.push({
              columnKey: 'action',
              label: '操作',
              width: 148,
              align: 'center',
              resizable: false,
              fixed: 'right',
              slot: 'action'
            });
          } else {
            privateColumn = [];
          }

          let newRes = res.map((m) => {
            return {
              prop: 'extField.' + m.prop,
              label: m.label,
              align: 'center',
              showOverflowTooltip: true
            };
          });

          this.newColumns = [...this.columns, ...newRes, ...privateColumn];

          this.$forceUpdate();
        });
      },

      handleTabChange() {
        this.$refs.searchRef.reset();
      },

      /* 刷新表格 */
      reload(where) {
        this.$nextTick(() => {
          this.$refs.table.reload({ page: 1, where });
        });
      },

      /* 数据转为树形结构 */
      parseData(data) {
        return {
          ...data,
          list: this.$util.toTreeData({
            data: data.list,
            count: data.total,

            idField: 'code',
            parentIdField: 'joinPlanCode'
          })
        };
      },

      handleDel(row) {
        this.$confirm('确定删除当前数据？', '提示')
          .then(() => {
            del(row.id).then((res) => {
              this.reload();
              this.$message.success('删除成功');
            });
          })
          .catch(() => {});
      },
      handleSelectionChange(list) {
        if (list.length > 1) {
          let _list = [];
          list.forEach((e) => {
            if (e.childList.length > 0 && e.splitBatch != 2) {
              _list.push(...e.childList);
            } else {
              _list.push(e);
            }
          });
          this.selection = _list;
        } else {
          this.selection = [];
        }
      },

      handOneSelection(row) {
        const index = this.selection.findIndex((item) => item.id == row.id);
        if (index >= 0) {
          this.selection.splice(index, 1);
        } else {
          this.selection.push(row);
        }
      },

      selectionFilter(row) {
        return this.selection.findIndex((item) => item.id == row.id) >= 0;
      },

      goDetail({ id }) {
        this.$router.push({
          path: '/productionPlan/detail/' + id
        });
      },

      //  计划分解
      disassemblePlan() {
        if (this.selection.length != 1) {
          return this.$message.warning('计划分解只能选择一个计划！');
        }

        this.$refs.disassemblePlanRef.open(this.selection[0]);
      },

      // 拆批
      toUnpack(row) {
        if (!row.batchNo) {
          return this.$message.error('请先填写批次号！');
        }
        this.$refs.unpackRef.open(row);
      },

      // 合并
      handleMerge() {
        if (this.selection.length <= 1) {
          return this.$message.warning('请先勾选二个或多个计划！');
        }
        const productCode = this.selection[0].productCode;
        const produceRoutingId = this.selection[0].produceRoutingId;

        for (var i = 0; i < this.selection.length; i++) {
          if (productCode != this.selection[i].productCode) {
            return this.$message.warning('产品编码不一致！');
          }

          if (produceRoutingId != this.selection[i].produceRoutingId) {
            return this.$message.warning('工艺路线不一致！');
          }
        }

        this.$refs.mergeRef.open(this.selection);

        console.log(this.selection);
      },

      splitDetails(type, row) {
        this.$refs.DetailsRef.open(type, row);
      },

      onSortChange(e) {
        let sort = {
          orderBy: e.order,
          sortName: e.prop
        };
        this.sort = sort;
        this.reload();
      },

      sortTop(row) {
        row.priority = Number(row.priority) + 1;
        this.priorityChange(row);
      },
      sortBottom(row) {
        if (row.priority <= 1) {
          return;
        }
        row.priority = Number(row.priority) - 1;
        this.priorityChange(row);
      },

      priorityChange(row) {
        if (row.priority > 10) {
          row.priority = 10; // 如果大于 10，则设置为 10
        } else if (row.priority < 0) {
          row.priority = 0; // 如果小于 0，则设置为 0
        }

        this.priorityFn(row);
      },
      priorityFn: debounce(function (row) {
        let params = {
          id: row.id,
          priority: row.priority
        };
        updatePriority(params).then((res) => {});
      }, 800)
    }
  };
</script>

<style lang="scss" scoped>
  .btn_box {
    margin-bottom: 6px;
  }

  .check_box {
    width: 100%;
    display: flex;
    align-items: center;
    justify-content: center;
    cursor: pointer;
  }

  .check {
    width: 14px;
    height: 14px;
    border: 1px solid #dddddd;

    display: flex;
    align-items: center;
    justify-content: center;
  }

  .act_check {
    border: 1px solid #409eff;
    background: #409eff;

    .el-icon-check {
      color: #fff;
      font-size: 10px;
    }
  }
</style>
